# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test;
BEGIN { plan tests => 6 };
use Inline;

#########################

# Insert your test code below, the Test module is use()ed here so read
# its man page ( perldoc Test ) for help writing this test script.

#0.1
ok(eval <<'   END',
   Inline->bind(C => 'int f2aXTN(int n) { return n + 3; }'),
   &f2aXTN(2)
   END
   5,
   "Inline::C isn't working.");

#0.2
ok((`swig -version 2>&1` =~ /SWIG/) ? 1 : 0,
   1,
   "Is swig installed? ('swig -version' didn't work)");

#0.3
ok(eval <<'   END',
   Inline->bind(SWIG => 'int fvU3d(int n) { return n + 3; }'),
   &fvU3d(2)
   END
   5,
   "The first simple (C code) test of Inline::SWIG failed.");

#0.4
ok(eval <<'   END',
   Inline->bind(SWIG => 'int fV1N8(int n) { return n + 3; }',
		SWIG_ARGS => '-c++', CC => "c++"),
   &fV1N8(2)
   END
   5,
   "The first simple (C++ code) test of Inline::SWIG failed.\nIs 'c++' installed?");

#0.5
ok(eval <<'   END',
   Inline->bind(SWIG => <<"   iGBIW", SWIG_ARGS => '-c++ -shadow', CC => "c++");
   class OVEsU {
     public:
       int meaning() { return 42; };
   };
   iGBIW
   OVEsU->new()->meaning()
   END
   42,
   "The first C++ class test failed.  Does your swig support -shadow?");


#0.6
sub tWPGP {
  $foo_h = <<"  END_OF_H";
  class DbJX {
    public: 
      int meaning();
  };
  END_OF_H
  Inline->bind(SWIG => <<"  END_OF_CODE", SWIG_INTERFACE => <<"  END_OF_I", SWIG_ARGS => '-c++ -shadow', CC => "c++");
  $foo_h
  int DbJX::meaning() { return 42; }  
  END_OF_CODE
%{
$foo_h
%}
%module FeC7
$foo_h
  END_OF_I
  return FeC7::DbJX->new()->meaning();
}
ok(eval <<'   END',
   &tWPGP()
   END
   42,
   "A C++ code plus interface test failed.");

